import { Body, Controller, Post, Req, Res } from '@nestjs/common';
import { BotFrameworkAdapter, TurnContext } from 'botbuilder';
import { Request, Response } from 'express';

import { ChatbotHandler } from './chatbot.handler';
import { ChatbotService } from './chatbot.service';

@Controller('bot')
export class ChatbotController {

    constructor(
        private readonly botService: ChatbotService,
        private readonly handler: ChatbotHandler) { }

    @Post('messages')
    public async parseMessages(@Req() request: Request, @Res() response: Response) {
        this.botService.adapter.processActivity(request, response, async (context) => {
            // Route to main dialog.
            await this.handler.run(context);
        });
    }
}
