import {MigrationInterface, QueryRunner} from 'typeorm';

export class SessionUpgrade1575155328623 implements MigrationInterface {
    public name = 'SessionUpgrade1575155328623';

    public async up(queryRunner: QueryRunner): Promise<any> {
        await queryRunner.query('DROP INDEX `IDX_170405c65085bc6d51187e60ac` ON `user`', undefined);
        await queryRunner.query('ALTER TABLE `user` DROP COLUMN `publicId`', undefined);
        await queryRunner.query('ALTER TABLE `user` ADD `publicId` varchar(255) NOT NULL', undefined);
        await queryRunner.query('ALTER TABLE `session` DROP FOREIGN KEY `FK_3d2f174ef04fb312fdebd0ddc53`', undefined);
        await queryRunner.query('ALTER TABLE `session` CHANGE `userId` `userId` varchar(36) NULL', undefined);
        await queryRunner.query('CREATE UNIQUE INDEX `IDX_170405c65085bc6d51187e60ac` ON `user` (`id`, `telegramId`, `publicId`)', undefined);
        await queryRunner.query('ALTER TABLE `session` ADD CONSTRAINT `FK_3d2f174ef04fb312fdebd0ddc53` FOREIGN KEY (`userId`) REFERENCES `user`(`id`) ON DELETE NO ACTION ON UPDATE NO ACTION', undefined);
    }

    public async down(queryRunner: QueryRunner): Promise<any> {
        await queryRunner.query('ALTER TABLE `session` DROP FOREIGN KEY `FK_3d2f174ef04fb312fdebd0ddc53`', undefined);
        await queryRunner.query('DROP INDEX `IDX_170405c65085bc6d51187e60ac` ON `user`', undefined);
        await queryRunner.query('ALTER TABLE `session` CHANGE `userId` `userId` varchar(36) NULL DEFAULT \'NULL\'', undefined);
        await queryRunner.query('ALTER TABLE `session` ADD CONSTRAINT `FK_3d2f174ef04fb312fdebd0ddc53` FOREIGN KEY (`userId`) REFERENCES `user`(`id`) ON DELETE NO ACTION ON UPDATE NO ACTION', undefined);
        await queryRunner.query('ALTER TABLE `user` DROP COLUMN `publicId`', undefined);
        await queryRunner.query('ALTER TABLE `user` ADD `publicId` int NOT NULL', undefined);
        await queryRunner.query('CREATE UNIQUE INDEX `IDX_170405c65085bc6d51187e60ac` ON `user` (`id`, `telegramId`, `publicId`)', undefined);
    }

}
