import { MigrationInterface, QueryRunner } from 'typeorm';

export class Event1579342694650 implements MigrationInterface {
    public name = 'Event1579342694650';

    public async up(queryRunner: QueryRunner): Promise<any> {
        await queryRunner.query('CREATE TABLE `events` (`id` varchar(36) NOT NULL, `title` varchar(255) NOT NULL, `location` varchar(255) NOT NULL, `description` varchar(255) NOT NULL, `dateStart` int(11) UNSIGNED NOT NULL, `dateEnd` int(11) UNSIGNED NOT NULL, `dateModified` int(11) UNSIGNED NOT NULL, `dateCreated` int(11) UNSIGNED NOT NULL, PRIMARY KEY (`id`)) ENGINE=InnoDB', undefined);
        await queryRunner.query('CREATE TABLE `user_events_events` (`userId` varchar(36) NOT NULL, `eventsId` varchar(36) NOT NULL, INDEX `IDX_5b8cfe39e087bcf197827e297f` (`userId`), INDEX `IDX_c65d11ffd13f04644bcf55bf06` (`eventsId`), PRIMARY KEY (`userId`, `eventsId`)) ENGINE=InnoDB', undefined);
        await queryRunner.query('ALTER TABLE `broadcasts` CHANGE `dateSent` `dateSent` datetime NULL', undefined);
        await queryRunner.query('DROP INDEX `IDX_170405c65085bc6d51187e60ac` ON `user`', undefined);
        await queryRunner.query('ALTER TABLE `session` DROP FOREIGN KEY `FK_3d2f174ef04fb312fdebd0ddc53`', undefined);
        await queryRunner.query('ALTER TABLE `session` CHANGE `userId` `userId` varchar(36) NULL', undefined);
        await queryRunner.query('CREATE UNIQUE INDEX `IDX_170405c65085bc6d51187e60ac` ON `user` (`id`, `telegramId`, `publicId`)', undefined);
        await queryRunner.query('ALTER TABLE `session` ADD CONSTRAINT `FK_3d2f174ef04fb312fdebd0ddc53` FOREIGN KEY (`userId`) REFERENCES `user`(`id`) ON DELETE NO ACTION ON UPDATE NO ACTION', undefined);
        await queryRunner.query('ALTER TABLE `user_events_events` ADD CONSTRAINT `FK_5b8cfe39e087bcf197827e297fd` FOREIGN KEY (`userId`) REFERENCES `user`(`id`) ON DELETE CASCADE ON UPDATE NO ACTION', undefined);
        await queryRunner.query('ALTER TABLE `user_events_events` ADD CONSTRAINT `FK_c65d11ffd13f04644bcf55bf065` FOREIGN KEY (`eventsId`) REFERENCES `events`(`id`) ON DELETE CASCADE ON UPDATE NO ACTION', undefined);
    }

    public async down(queryRunner: QueryRunner): Promise<any> {
        await queryRunner.query('ALTER TABLE `user_events_events` DROP FOREIGN KEY `FK_c65d11ffd13f04644bcf55bf065`', undefined);
        await queryRunner.query('ALTER TABLE `user_events_events` DROP FOREIGN KEY `FK_5b8cfe39e087bcf197827e297fd`', undefined);
        await queryRunner.query('ALTER TABLE `session` DROP FOREIGN KEY `FK_3d2f174ef04fb312fdebd0ddc53`', undefined);
        await queryRunner.query('DROP INDEX `IDX_170405c65085bc6d51187e60ac` ON `user`', undefined);
        await queryRunner.query('ALTER TABLE `session` CHANGE `userId` `userId` varchar(36) NULL DEFAULT \'NULL\'', undefined);
        await queryRunner.query('ALTER TABLE `session` ADD CONSTRAINT `FK_3d2f174ef04fb312fdebd0ddc53` FOREIGN KEY (`userId`) REFERENCES `user`(`id`) ON DELETE NO ACTION ON UPDATE NO ACTION', undefined);
        await queryRunner.query('CREATE UNIQUE INDEX `IDX_170405c65085bc6d51187e60ac` ON `user` (`id`, `telegramId`, `publicId`)', undefined);
        await queryRunner.query('ALTER TABLE `broadcasts` CHANGE `dateSent` `dateSent` datetime NULL DEFAULT \'NULL\'', undefined);
        await queryRunner.query('DROP INDEX `IDX_c65d11ffd13f04644bcf55bf06` ON `user_events_events`', undefined);
        await queryRunner.query('DROP INDEX `IDX_5b8cfe39e087bcf197827e297f` ON `user_events_events`', undefined);
        await queryRunner.query('DROP TABLE `user_events_events`', undefined);
        await queryRunner.query('DROP TABLE `events`', undefined);
    }

}
