import { forwardRef, Module } from '@nestjs/common';
import { TypeOrmModule } from '@nestjs/typeorm';

import { UserModule } from '../user/user.module';

import { OrganiserController } from './organiser.controller';
import { Organiser } from './organiser.entity';
import { OrganiserService } from './organiser.service';

@Module({
  imports: [
    TypeOrmModule.forFeature([Organiser]),
    forwardRef(() => UserModule)
  ],
  providers: [OrganiserService],
  controllers: [OrganiserController],
  exports: [
    TypeOrmModule,
    OrganiserService
  ]
})
export class OrganiserModule {}
