import { Column, CreateDateColumn, Entity, Generated, JoinTable, ManyToMany, OneToMany, PrimaryGeneratedColumn, Unique } from 'typeorm';

import { EventAttendee } from '../events/attendee.entity';
import { Event } from '../events/event.entity';

@Entity()
@Unique(['id', 'telegramId', 'publicId'])
export class User {

  @PrimaryGeneratedColumn('uuid')
  public id: string;

  @Column()
  public telegramId: string;

  @Column()
  @Generated('uuid')
  public publicId: string;

  @Column()
  public name: string;

  @OneToMany(
    (type) => EventAttendee,
    (attendance) => attendance.user,
    { lazy: true })
  public events: Promise<EventAttendee[]>;

  @CreateDateColumn()
  public dateCreated: Date;
}
