import { Column, CreateDateColumn, Entity, ManyToOne, PrimaryGeneratedColumn, Unique } from 'typeorm';

import { User } from './user.entity';
import { UserMetaEnum } from './usermeta.enum';

@Entity()
@Unique(['key', 'value', 'user'])
export class UserMeta {

  @PrimaryGeneratedColumn()
  public id: number;

  @Column({ type: 'varchar' })
  public key: UserMetaEnum | string;

  @Column({ type: 'text' })
  public value: string;

  @ManyToOne((type) => User, { onDelete: 'CASCADE' })
  public user: User;

  @CreateDateColumn()
  public dateCreated: Date;
}
