export class DateFormater {
  /**
   * Transforms a timestamp to a string representing ics utc date time format
   * @param date as timestamp
   * @param isAllDay
   */
  public static toICSUTC(date: number, isAllDay: boolean): string {
    const unixToDate = new Date(1000 * date);
    unixToDate.setMilliseconds(0);
    const noMsDateISOString = unixToDate.toISOString();
    const icsDateString = noMsDateISOString.replace(/-/g, '').replace(/:/g, '').replace(/\.000/g, '');
    return isAllDay ? icsDateString.substring(0, icsDateString.indexOf('T')) : icsDateString;
  }

  public static unixToDate(unix: number): Date {
    return new Date(1000 * unix);
  }

  public static dateToUnix(date: Date): number {
    return Math.round(date.getTime() / 1000);
  }
}
