import { Like, MoreThanOrEqual } from 'typeorm';

export class QueryBuilder {
  public static buildTypeORMQuery(query: ParameterDecorator): any[] {
    const typeORMQuery = [];

    typeORMQuery.push({});
    let index = 0;

    Object.keys(query).forEach((key) => {
      if (key !== 'OR' && key !== 'limit' && key !== 'page' && query[key] !== '') {
        if (key.endsWith('__like')) {
          typeORMQuery[index][key.substring(0, key.length - 6)] = Like(`%${query[key]}%`);
        } else if (key.endsWith('__gteq')) {
          typeORMQuery[index][key.substring(0, key.length - 6)] = MoreThanOrEqual(parseInt(query[key], 10));
        } else {
          const parsedString = parseInt(query[key], 10);
          typeORMQuery[index][key] = isNaN(parsedString) ? query[key] : parsedString;
        }
      }
      if (key === 'OR') {
        typeORMQuery.push({});
        index += 1;
      }

    });

    if (Object.keys(typeORMQuery[index]).length === 0) {
      typeORMQuery.splice(index, 1);
    }
    return typeORMQuery;
  }
}
